diff --git a/test/unit/stages/review/completion_evidence_test.rb b/test/unit/stages/review/completion_evidence_test.rb
new file mode 100644
index 00000000..7f33ae0d
--- /dev/null
+++ b/test/unit/stages/review/completion_evidence_test.rb
@@ -0,0 +1,248 @@
+require "test_helper"
+require "json"
+require "hive/stages/review"
+
+class ReviewCompletionEvidenceTest < Minitest::Test
+  include HiveTestHelper
+
+  Task = Struct.new(:slug)
+
+  def test_accepts_changed_manifest_with_zero_exit_descendant_commit_and_clean_worktree
+    with_tmp_git_repo do |worktree|
+      task_folder, ctx, task = review_context(worktree)
+      baseline = git_head(worktree)
+      binding = Hive::Stages::Review::CompletionEvidence.prepare!(
+        task: task, ctx: ctx, accepted_findings: 1, baseline_head: baseline
+      )
+      File.write(File.join(worktree, "fix.rb"), "fixed\n")
+      run!("git", "-C", worktree, "add", "fix.rb")
+      run!("git", "-C", worktree, "commit", "-m", "fix")
+      write_result(binding, outcome: "changed", status: "addressed")
+
+      evaluation = Hive::Stages::Review::CompletionEvidence.evaluate(
+        task: task, ctx: ctx, binding: binding,
+        observation: observation, worktree_path: worktree,
+        wrapper_completion_recorded: true
+      )
+
+      assert evaluation.accepted, evaluation.reason
+      assert_equal "changed", evaluation.result.outcome
+      assert_equal git_head(worktree), evaluation.head
+    end
+  end
+
+  def test_accepts_explicit_no_change_manifest_only_with_clean_unchanged_head
+    with_tmp_git_repo do |worktree|
+      _task_folder, ctx, task = review_context(worktree)
+      baseline = git_head(worktree)
+      binding = Hive::Stages::Review::CompletionEvidence.prepare!(
+        task: task, ctx: ctx, accepted_findings: 1, baseline_head: baseline
+      )
+      write_result(binding, outcome: "no_changes_needed", status: "already_resolved")
+
+      evaluation = Hive::Stages::Review::CompletionEvidence.evaluate(
+        task: task, ctx: ctx, binding: binding,
+        observation: observation, worktree_path: worktree,
+        wrapper_completion_recorded: true
+      )
+
+      assert evaluation.accepted, evaluation.reason
+      assert_equal [ "finding already resolved" ], evaluation.no_change_evidence
+    end
+  end
+
+  def test_rejects_missing_or_contradictory_manifest_and_unrecorded_wrapper
+    with_tmp_git_repo do |worktree|
+      _task_folder, ctx, task = review_context(worktree)
+      binding = Hive::Stages::Review::CompletionEvidence.prepare!(
+        task: task, ctx: ctx, accepted_findings: 1, baseline_head: git_head(worktree)
+      )
+
+      missing = Hive::Stages::Review::CompletionEvidence.evaluate(
+        task: task, ctx: ctx, binding: binding,
+        observation: observation, worktree_path: worktree,
+        wrapper_completion_recorded: true
+      )
+      refute missing.accepted
+      assert_match(/missing/, missing.reason)
+
+      write_result(binding, outcome: "no_changes_needed", status: "already_resolved")
+      wrapper = Hive::Stages::Review::CompletionEvidence.evaluate(
+        task: task, ctx: ctx, binding: binding,
+        observation: observation, worktree_path: worktree,
+        wrapper_completion_recorded: false
+      )
+      refute wrapper.accepted
+      assert_match(/wrapper/, wrapper.reason)
+
+      wrong_exit = Hive::Stages::Review::CompletionEvidence.evaluate(
+        task: task, ctx: ctx, binding: binding,
+        observation: observation.merge(process_exit_code: 1), worktree_path: worktree,
+        wrapper_completion_recorded: true
+      )
+      refute wrong_exit.accepted
+      assert_match(/zero/, wrong_exit.reason)
+    end
+  end
+
+  def test_accepted_fallback_emits_one_warning_audit_event
+    with_tmp_dir do |dir|
+      task = Struct.new(:folder, :slug, :stage_index, :stage_name).new(dir, "fallback-task", 6, "review")
+      ctx = Hive::Stages::Review::Context.new(
+        worktree_path: task.folder, task_folder: task.folder, default_branch: "master", pass: 1
+      )
+      completion = Hive::Stages::Review::CompletionEvidence::Evaluation.new(
+        accepted: true, reason: nil, result: nil, head: "abc123",
+        artifacts_checked: [ "fix-result-01.json", "escalations-01.md", "absent:errors-01.md" ],
+        no_change_evidence: nil
+      )
+      observation = {
+        pid: 4321, session: "hive-review", expected_sentinel_path: File.join(task.folder, ".done"),
+        missing_signal_reason: "claude stop hook did not signal completion"
+      }
+
+      Hive::Stages::Review.emit_claude_completion_fallback(task, ctx, observation, completion)
+
+      records = File.readlines(File.join(task.folder, "events.jsonl"), chomp: true).map { |line| JSON.parse(line) }
+      fallback = records.select { |record| record["event_type"] == "claude_completion_fallback" }
+      assert_equal 1, fallback.size
+      assert_equal "warn", fallback.first.fetch("level")
+      assert_equal "fix", fallback.first.fetch("metadata").fetch("phase")
+      assert_equal "abc123", fallback.first.fetch("metadata").fetch("commit_sha")
+      assert_equal [ "fix-result-01.json", "escalations-01.md", "absent:errors-01.md" ],
+                   fallback.first.fetch("metadata").fetch("artifacts_checked")
+    end
+  end
+
+  def test_rejects_symlinked_oversized_stale_nonce_wrong_pass_and_baseline
+    with_tmp_git_repo do |worktree|
+      _task_folder, ctx, task = review_context(worktree)
+      baseline = git_head(worktree)
+      binding = Hive::Stages::Review::CompletionEvidence.prepare!(
+        task: task, ctx: ctx, accepted_findings: 1, baseline_head: baseline
+      )
+
+      write_result(binding, outcome: "no_changes_needed", status: "already_resolved")
+      FileUtils.rm_f(binding.fetch(:path))
+      target = File.join(File.dirname(binding.fetch(:path)), "payload.json")
+      File.write(target, "{}")
+      File.symlink(target, binding.fetch(:path))
+      symlinked = evaluate(task, ctx, binding, worktree)
+      refute symlinked.accepted
+      assert_match(/regular file|symlink/i, symlinked.reason)
+      FileUtils.rm_f(binding.fetch(:path))
+
+      oversized = "x" * (Hive::Stages::Review::CompletionEvidence::MAX_RESULT_BYTES + 1)
+      File.write(binding.fetch(:path), oversized)
+      big = evaluate(task, ctx, binding, worktree)
+      refute big.accepted
+      assert_match(/oversized|empty/i, big.reason)
+
+      write_result(binding, outcome: "no_changes_needed", status: "already_resolved")
+      stale = evaluate(task, ctx, binding.merge(nonce: "stale-nonce-not-bound"), worktree)
+      refute stale.accepted
+      assert_match(/binding does not match/i, stale.reason)
+
+      wrong_pass = evaluate(task, ctx, binding.merge(pass: 99), worktree)
+      refute wrong_pass.accepted
+      assert_match(/binding does not match/i, wrong_pass.reason)
+
+      wrong_baseline = evaluate(
+        task, ctx, binding.merge(baseline_head: "0" * 40), worktree
+      )
+      refute wrong_baseline.accepted
+      assert_match(/binding does not match/i, wrong_baseline.reason)
+    end
+  end
+
+  def test_rejects_unanswered_escalation_errors_file_and_unreadable_worktree
+    with_tmp_git_repo do |worktree|
+      task_folder, ctx, task = review_context(worktree)
+      baseline = git_head(worktree)
+      binding = Hive::Stages::Review::CompletionEvidence.prepare!(
+        task: task, ctx: ctx, accepted_findings: 1, baseline_head: baseline
+      )
+      write_result(binding, outcome: "no_changes_needed", status: "already_resolved")
+
+      File.write(
+        File.join(task_folder, "reviews", "escalations-01.md"),
+        "# Escalations\n\n- [ ] still open for human\n"
+      )
+      unanswered = evaluate(task, ctx, binding, worktree)
+      refute unanswered.accepted
+      assert_match(/unanswered escalation/i, unanswered.reason)
+
+      File.write(File.join(task_folder, "reviews", "escalations-01.md"), "# Escalations\n\n_All clean._\n")
+      File.write(File.join(task_folder, "reviews", "errors-01.md"), "- [ ] reviewer died\n")
+      errors = evaluate(task, ctx, binding, worktree)
+      refute errors.accepted
+      assert_match(/infrastructure error/i, errors.reason)
+      FileUtils.rm_f(File.join(task_folder, "reviews", "errors-01.md"))
+
+      unreadable = evaluate(task, ctx, binding, File.join(worktree, "does-not-exist"))
+      refute unreadable.accepted
+      assert_match(/worktree|unreadable|completion evidence/i, unreadable.reason)
+    end
+  end
+
+  def test_accepted_result_lists_errors_as_absent_in_artifacts_checked
+    with_tmp_git_repo do |worktree|
+      _task_folder, ctx, task = review_context(worktree)
+      binding = Hive::Stages::Review::CompletionEvidence.prepare!(
+        task: task, ctx: ctx, accepted_findings: 1, baseline_head: git_head(worktree)
+      )
+      write_result(binding, outcome: "no_changes_needed", status: "already_resolved")
+
+      evaluation = evaluate(task, ctx, binding, worktree)
+      assert evaluation.accepted, evaluation.reason
+      assert_includes evaluation.artifacts_checked, "absent:errors-01.md"
+      refute_includes evaluation.artifacts_checked, "errors-01.md"
+    end
+  end
+
+  private
+
+  def review_context(worktree)
+    task_folder = File.join(File.dirname(worktree), "stage-task")
+    reviews = File.join(task_folder, "reviews")
+    FileUtils.mkdir_p(reviews)
+    File.write(File.join(reviews, "reviewer-01.md"), "## High\n- [x] a finding\n")
+    File.write(File.join(reviews, "escalations-01.md"), "# Escalations\n\n_All clean._\n")
+    ctx = Hive::Stages::Review::Context.new(
+      worktree_path: worktree, task_folder: task_folder, default_branch: "master", pass: 1
+    )
+    [ task_folder, ctx, Task.new("task") ]
+  end
+
+  def write_result(binding, outcome:, status:)
+    body = {
+      "schema_version" => 1,
+      "slug" => binding.fetch(:slug),
+      "pass" => binding.fetch(:pass),
+      "nonce" => binding.fetch(:nonce),
+      "baseline_head" => binding.fetch(:baseline_head),
+      "accepted_findings" => binding.fetch(:accepted_findings),
+      "outcome" => outcome,
+      "resolutions" => [
+        { "finding" => 1, "status" => status, "detail" => "finding already resolved" }
+      ]
+    }
+    File.write(binding.fetch(:path), JSON.generate(body))
+  end
+
+  def evaluate(task, ctx, binding, worktree)
+    Hive::Stages::Review::CompletionEvidence.evaluate(
+      task: task, ctx: ctx, binding: binding,
+      observation: observation, worktree_path: worktree,
+      wrapper_completion_recorded: true
+    )
+  end
+
+  def observation
+    { process_exit_code: 0, session: "hive-test", expected_sentinel_path: "/tmp/.done" }
+  end
+
+  def git_head(worktree)
+    `git -C #{worktree.shellescape} rev-parse HEAD`.strip
+  end
+end
diff --git a/test/unit/stop_hook_installer_test.rb b/test/unit/stop_hook_installer_test.rb
index 71b2a57a..40e288ca 100644
--- a/test/unit/stop_hook_installer_test.rb
+++ b/test/unit/stop_hook_installer_test.rb
@@ -70,6 +70,26 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_worktree_discovered_hook_writes_only_to_stage_owned_signal_paths
+    with_tmp_dir do |stage_dir|
+      Dir.mktmpdir("hive worktree with spaces ") do |worktree|
+        paths = Hive::StopHookInstaller.install(stage_dir: stage_dir, extra_dirs: [ worktree ])
+        worktree_settings = paths.find { |path| path.start_with?(worktree) }
+        command = JSON.parse(File.read(worktree_settings))
+                      .dig("hooks", "Stop", 0, "hooks", 0, "command")
+
+        payload = %({"status":"ok","session_id":"from-worktree"})
+        _out, err, status = Open3.capture3(command, chdir: worktree, stdin_data: payload)
+
+        assert status.success?, err
+        assert_equal payload, File.read(File.join(stage_dir, "result.json"))
+        assert File.exist?(File.join(stage_dir, ".done"))
+        refute File.exist?(File.join(worktree, "result.json"))
+        refute File.exist?(File.join(worktree, ".done"))
+      end
+    end
+  end
+
   def test_install_skips_extra_dir_equal_to_stage_dir
     with_tmp_dir do |dir|
       paths = Hive::StopHookInstaller.install(stage_dir: dir, extra_dirs: [ dir ])
@@ -137,6 +157,21 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_stop_hook_publishes_result_before_done_and_never_signals_failed_write
+    with_tmp_dir do |dir|
+      # A non-directory stage path makes the result temp-file creation fail.
+      # The hook must not leave the .done wake-up sentinel behind in that
+      # case.
+      stage_file = File.join(dir, "not-a-stage-directory")
+      File.write(stage_file, "not a directory\n")
+      _out, _err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => stage_file }, HOOK, stdin_data: '{"status":"ok"}')
+
+      refute status.success?
+      refute File.exist?("#{stage_file}/.done"),
+             "a failed result publish must not advertise completion"
+    end
+  end
+
   def test_stop_hook_requires_stage_dir_env
     # Scrub HIVE_TASK_STAGE_DIR from the child env so the test is hermetic even
     # when the surrounding shell exports it (e.g. under the review harness);
diff --git a/test/unit/tmux_runner_test.rb b/test/unit/tmux_runner_test.rb
index 005bccda..71dbc24e 100644
--- a/test/unit/tmux_runner_test.rb
+++ b/test/unit/tmux_runner_test.rb
@@ -306,6 +306,44 @@ class TmuxRunnerTest < Minitest::Test
     end
   end
 
+  def test_pane_state_retains_clean_exit_status
+    with_tmp_dir do |dir|
+      skip "tmux unavailable" unless tmux_available?
+
+      runner = runner(name: unique_name("dead-status"), cwd: dir)
+      runner.start_detached(command: [ "sh", "-c", "exit 0" ])
+
+      state = nil
+      deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + 5
+      until state&.dead? || Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+        state = runner.pane_state
+        sleep 0.05 unless state.dead?
+      end
+
+      assert state.dead?, "managed pane should remain inspectable after command exit"
+      assert_equal 0, state.exit_status
+    ensure
+      runner&.kill_session
+    end
+  end
+
+  def test_pane_state_reports_unparseable_dead_status_as_unknown
+    with_tmp_dir do |dir|
+      fake = write_fake_tmux(dir, <<~SH)
+        #!/bin/sh
+        if [ "$1" = "display-message" ]; then
+          printf '1|not-a-status|1234\\n'
+        fi
+      SH
+      runner = Hive::TmuxRunner.new(name: unique_name("bad-status"), cwd: dir, tmux_bin: fake)
+
+      state = runner.pane_state
+      assert state.dead?
+      assert_nil state.exit_status
+      assert_equal 1234, state.pid
+    end
+  end
+
   def test_capture_pane_tail_scrubs_invalid_utf8
     with_tmp_dir do |dir|
       fake = write_fake_tmux(dir, <<~SH)
